# -*- coding: utf-8 -*-
# yes, this could all be dynamically generated on import...
# but most IDE's are not smart enough to figure that out.  thus,
# this...which only needs to be run very, very occasionally.
# premake some scopes
NAMED_SCOPES = [
    "character_event",
    "letter_event",
    "narrative_event",
    "any_attacker",
    "any_backed_character",
    "any_child",
    "any_courtier",
    "any_current_enemy",
    "any_de_jure_vassal",
    "any_defender",
    "any_dynasty_member",
    "any_friend",
    "any_independent_ruler",
    "any_liege",
    "any_lover",
    "any_playable_ruler",
    "any_plot_backer",
    "any_province_character",
    "any_province_lord",
    "any_realm_character",
    "any_realm_lord",
    "any_rival",
    "any_sibling",
    "any_spouse",
    "any_consort",
    "any_trade_post",
    "any_vassal",
    "any_ward",
    "attacker",
    "controller",
    "current_heir",
    "defender",
    "employer",
    "father",
    "father_even_if_dead",
    "father_of_unborn",
    "guardian",
    "heir_under_seniority_law",
    "heir_under_primogeniture_law",
    "holder_scope",
    "host",
    "leader",
    "liege",
    "liege_before_war",
    "lover",
    "most_participating_attacker",
    "most_participating_defender",
    "mother",
    "mother_even_if_dead",
    "new_character",
    "owner",
    "parent_religion_head",
    "plot_target_char",
    "random_backed_character",
    "random_child",
    "random_courtier",
    "random_current_enemy",
    "random_dynasty_member",
    "random_friend",
    "random_independent_ruler",
    "random_lover",
    "random_playable_ruler",
    "random_province_character",
    "random_province_lord",
    "random_realm_character",
    "random_realm_lord",
    "random_rival",
    "random_sibling",
    "random_spouse",
    "random_consort",
    "random_trade_post",
    "random_vassal",
    "random_ward",
    "regent",
    "religion_head",
    "rightful_religious_head_scope",
    "ruler",
    "spouse",
    "spouse_even_if_dead",
    "supported_claimant",
    "top_liege",
    "trade_post_owner",
    "job_chancellor",
    "job_marshal",
    "job_treasurer",
    "job_spymaster",
    "job_spiritual",
    "any_claim",
    "any_de_jure_vassal_title",
    "any_demesne_title",
    "any_heir_title",
    "any_potential_tribal_county",
    "any_pretender_title",
    "any_realm_title",
    "capital_holding",
    "county",
    "crownlaw_title",
    "crusade_target",
    "dejure_liege_title",
    "duchy",
    "empire",
    "invasion_target",
    "kingdom",
    "plot_target_title",
    "primary_title",
    "random_claim",
    "random_demesne_title",
    "random_potential_tribal_county",
    "supported_claimant_title",
    "realm",
    "any_demesne_province",
    "any_neighbor_province",
    "any_realm_province",
    "capital_scope",
    "location",
    "plot_target_province",
    "random_demesne_province",
    "random_neighbor_province",
    "random_realm_province",
    "tooltip",
    "hidden_tooltip",
    "any_war",
    "enemy",
    "siege",
    "any_empty_neighbor_province",
    "any_garrisoned_province",
    "any_host_courtier",
    "any_owned",
    "any_province",
    "any_title",
    "any_title_under",
    "arranged_marriages",
    "empty_provinces",
    "enemy_provinces",
    "independent_titles",
    "location_ruler_title",
    "occupier",
    "other_de_jure_claim",
    "preferred_heir",
    "random_empty_neighbor_province",
    "realm_titles",
    "unborn",
    "assimilating_liege",
    "family",
    "known_plots",
    "lasthost",
    "liege_titles",
    "family_palace",
]


docstr = '{limit = {a_limit} a_block}'
line = """
def {}(a_limit, a_block):
    '''{} = {}'''
    return make_scope('{}', a_limit, a_block)

"""
with open('scope_gen.py', 'w') as _fp:
    _fp.write('from base import make_scope\n')
    for ascope in NAMED_SCOPES:
        _fp.write(line.format(ascope, ascope, docstr, ascope, ascope))

conditions = {
    "age": ("The age of a character. Can be any whole number", "character", "int"),
    "ai": ("If yes, will only fire for ai characters", "character", "bool"),
    "always": ("", "", ""),
    "attribute_diff": ("", "", ""),
    "at_location": ("", "", ""),
    "at_sea": ("", "", ""),
    "can_be_given_away": ("", "", ""),
    "can_change_religion": ("", "", ""),
    "can_have_more_leadership_traits": ("", "", ""),
    "can_marry": ("", "", ""),
    "capable_only": ("If yes, only picks characters without the Incapable trait", "", "bool"),
    "capital": ("", "", ""),
    "character": ("", "", ""),
    "check_variable": ("", "", ""),
    "claimed_by": ("", "", ""),
    "completely_controls": ("", "", ""),
    "conquest_culture": ("", "", ""),
    "continent": ("", "", ""),
    "controlled_by": ("", "", ""),
    "controls_religion": ("If yes, only picks characters who are the head of their religion", "character", "bool"),
    "count": ("", "", ""),
    "culture": ("Checks if the character has this specific culture", "character", "string"),
    "culture_group": ("Checks if the character is part of this culturegroup", "character", "string"),
    "defending_against_claimant": ("", "", ""),
    "dismissal_trigger": ("", "", ""),
    "demesne_efficiency": ("", "", ""),
    "demesne_size": ("Checks if the character has a minimum of this demesne size", "character", "int"),
    "de_facto_liege": ("", "", ""),
    "de_jure_liege": ("", "", ""),
    "de_jure_liege_or_above": ("", "", ""),
    "de_jure_vassal_or_below": ("", "", ""),
    "decadence": ("", "", ""),
    "dynasty": ("The character's dynasty, indexed by an integer value.", "character", "int"),
    "diplomacy": ("The character's Diplomacy stat.", "character", "int"),
    "distance": ("Determines the minimum distance from the scope (Example : distance = { who = ROOT distance = 100 } } (if you use NOT, it becomes maximum distance )", "character", "int"),
    "dynasty_realm_power": ("", "", ""),
    "excommunicated_for": ("", "", ""),
    "faction_power": ("", "", ""),
    "family": ("", "", ""),
    "father_of_unborn_known": ("Checks if a pregnant woman's unborn child has a known father.", "character", "bool"),
    "fertility": ("The character's fertility value. In-game, can only be seen through the \"charinfo\" console command.", "character", "int"),
    "flank_has_leader": ("", "", ""),
    "gold": ("How much money a character has.", "character", "int"),
    "graphical_culture": ("A character's graphical culture. In-game, can only be seen through the \"charinfo\" console command.", "character", ""),
    "had_character_flag": ("", "", ""),
    "had_dynasty_flag": ("", "", ""),
    "had_global_flag": ("", "", ""),
    "had_province_flag": ("", "", ""),
    "has_ambition": ("", "", ""),
    "has_building": ("", "", ""),
    "has_called_crusade": ("", "", ""),
    "has_character_flag": ("Checks if a character has a specified flag. NOTE: \"flags\" in CKII scripting are not pre-determined or stored anywhere, they are dynamically created in the script. A mistyped flag will not be caught by the Validator, as there are no \"invalid\" flags.", "character", "string"),
    "has_character_modifier": ("Checks if the character has this modifier", "character", "string"),
    "has_claim": ("", "", ""),
    "has_crown_law_title": ("Used to check crown laws for a specified title. Is not a condition itself though, it must be used as a scope to check crown laws by category (succession, for instance).", "title", "bool"),
    "has_de_jure_pretension": ("", "", ""),
    "has_disease": ("", "", ""),
    "has_dlc": ("checks if the user has a specified DLC. While it returns a bool, it must be checked against a string (example code: has_dlc = \"The Old Gods\").", "", "string/bool"),
    "has_dynasty_flag": ("", "", ""),
    "has_earmarked_regiments": ("", "", ""),
    "has_empty_holding": ("", "", ""),
    "has_epidemic": ("", "", ""),
    "has_global_flag": ("", "", ""),
    "has_guardian": ("", "", ""),
    "has_heresies": ("", "", ""),
    "has_higher_tech_than": ("", "", ""),
    "has_holder": ("", "", ""),
    "has_horde_culture": ("", "", ""),
    "has_job_action": ("", "", ""),
    "has_job_title": ("", "", ""),
    "has_landed_title": ("", "", ""),
    "has_law": ("", "", ""),
    "has_lover": ("Yes if the character has a lover", "character", "bool"),
    "has_minor_title": ("Yes if the character has a minor title", "character", "bool"),
    "has_nickname": ("", "", ""),
    "has_objective": ("", "", ""),
    "has_opinion_modifier": ("", "", ""),
    "has_owner": ("", "", ""),
    "has_plot": ("", "", ""),
    "has_province_flag": ("", "", ""),
    "has_province_modifier": ("", "", ""),
    "has_raised_levies": ("", "", ""),
    "has_regent": ("", "", ""),
    "has_siege": ("", "", ""),
    "has_strong_claim": ("", "", ""),
    "has_trade_post": ("", "", ""),
    "has_truce": ("", "", ""),
    "has_weak_claim": ("", "", ""),
    "health": ("A character's health value. In-game, can only be seen through the \"charinfo\" console command.", "character", ""),
    "health_traits": ("", "", ""),
    "higher_tier_than": ("", "", ""),
    "holy_order": ("", "", ""),
    "imprisoned_days": ("", "", ""),
    "independent": ("", "", ""),
    "intrigue": ("A character's Intrigue stat.", "character", "int"),
    "intrigue": ("", "", ""),
    "in_battle": ("", "", ""),
    "in_command": ("", "", ""),
    "in_faction": ("", "", ""),
    "in_revolt": ("", "", ""),
    "in_siege": ("", "", ""),
    "is_abroad": ("Valid if character is 'abroad' (not at liege's court)", "", "bool"),
    "is_adult": ("Checks if the character is an adult.", "character", "bool"),
    "is_alive": ("If yes, will only affect alive characters", "", "bool"),
    "is_at_sea": ("", "", ""),
    "is_attacker": ("", "", ""),
    "is_betrothed": ("If yes, will only affect bethrothed characters", "character", "bool"),
    "is_capital": ("If yes, will only affect the capital HOLDING", "", "bool"),
    "is_chancellor": ("If yes, will only trigger if the character is a chancellor", "", "bool"),
    "is_child_of": ("Checks if the scope is a child of ...", "character", "string"),
    "is_close_relative": ("checks if the scope is a close relative of ...", "character", "string"),
    "is_conquered": ("", "", ""),
    "is_consort": ("", "character", "bool"),
    "is_contested": ("", "", ""),
    "is_councillor": ("", "", ""),
    "is_father": ("", "", ""),
    "is_father_real_father": ("", "", ""),
    "is_female": ("If yes, will only affect female characters", "character", "bool"),
    "is_feudal": ("Checks if a character's primary title (or if a title itself) is a feudal one.", "character/title", "bool"),
    "is_friend": ("Checks if this character is a friend of the given character (e.g. is_friend = ROOT)", "character", "bool"),
    "is_guardian": ("", "", ""),
    "is_heresy_of": ("", "", ""),
    "is_heretic": ("", "", ""),
    "is_holy_war": ("", "", ""),
    "is_hostile": ("", "", ""),
    "is_ill": ("", "", ""),
    "is_independence": ("", "", ""),
    "is_ironman": ("", "", ""),
    "is_land": ("", "", ""),
    "is_landed": ("", "", ""),
    "is_landless_type_title": ("", "", ""),
    "is_liege_of": ("", "", ""),
    "is_liege_or_above": ("", "", ""),
    "is_located_in": ("", "", ""),
    "is_lover": ("Checks if this character is a lover of the given character (Example : is_lover = ROOT)", "character", "bool"),
    "is_main_spouse": ("", "", ""),
    "is_marriage_adult": ("", "", ""),
    "is_married": ("Yes, will only affect married charactes", "character", "bool"),
    "is_marshal": ("", "", ""),
    "is_merchant_republic": ("", "", ""),
    "is_mother": ("", "", ""),
    "is_occupied": ("", "", ""),
    "is_older_than": ("", "", ""),
    "is_parent_religion": ("", "", ""),
    "is_patrician": ("Checks if a character is the head of a Merchant Republic patrician family.", "character", "bool"),
    "is_playable": ("Only affects playable characters", "character", "bool"),
    "is_plot_active": ("", "", ""),
    "is_plot_target_of": ("", "", ""),
    "is_pregnant": ("", "", ""),
    "is_pretender": ("", "", ""),
    "is_priest": ("", "", ""),
    "is_primary_heir": ("", "", ""),
    "is_primary_holder_title": ("", "", ""),
    "is_primary_holder_title_tier": ("", "", ""),
    "is_primary_type_title": ("", "", ""),
    "is_primary_war_attacker": ("", "", ""),
    "is_primary_war_defender": ("", "", ""),
    "is_recent_grant": ("", "", ""),
    "is_reformed_religion": ("", "", ""),
    "is_republic": ("", "", ""),
    "is_ruler": ("Yes, will only affect characters who have a title (who are a ruler)", "character", "bool"),
    "is_spiritual": ("", "", ""),
    "is_spymaster": ("Yes, will only affect characters who are a spymaster", "character", "bool"),
    "is_theocracy": ("", "", ""),
    "is_title_active": ("", "", ""),
    "is_titular": ("", "", ""),
    "is_treasurer": ("", "", ""),
    "is_tribal_type_title": ("", "", ""),
    "is_valid": ("", "", ""),
    "is_valid_attraction": ("", "", ""),
    "is_vassal_or_below": ("", "", ""),
    "leads_faction": ("", "", ""),
    "learning": ("A character's Learning stat.", "character", "int"),
    "lifestyle_traits": ("", "", ""),
    "likes_better_than": ("", "", ""),
    "loot": ("", "", ""),
    "lower_tier_than": ("Yes, will only affect characters who are of a lower tier", "character", "string"),
    "martial": ("A character's Martial stat.", "character", "int"),
    "max_age": ("Maximum age of the character (for this event)", "character", "string"),
    "mercenary": ("", "", ""),
    "min_age": ("minimum age of the character (for this event)", "character", "string"),
    "month": ("", "", ""),
    "not_if_x_exists": ("", "", ""),
    "num_culture_realm_provs": ("", "", ""),
    "num_of_baron_titles": ("", "", ""),
    "num_of_buildings": ("", "", ""),
    "num_of_children": ("", "", ""),
    "num_of_claims": ("", "", ""),
    "num_of_count_titles": ("", "", ""),
    "num_of_duke_titles": ("", "", ""),
    "num_of_emperor_titles": ("", "", ""),
    "num_of_extra_landed_titles": ("", "", ""),
    "num_of_faction_backers": ("", "", ""),
    "num_of_friends": ("", "", ""),
    "num_of_holy_sites": ("", "", ""),
    "num_of_king_titles": ("", "", ""),
    "num_of_plot_backers": ("", "", ""),
    "num_of_prisoners": ("", "", ""),
    "num_of_realm_counties": ("", "", ""),
    "num_of_rivals": ("", "", ""),
    "num_of_settlements": ("", "", ""),
    "num_of_titles": ("", "", ""),
    "num_of_trade_posts": ("", "", ""),
    "num_of_trade_post_diff": ("", "", ""),
    "num_of_traits": ("", "", ""),
    "num_of_vassals": ("", "", ""),
    "num_title_realm_provs": ("", "", ""),
    "num_traits": ("", "", ""),
    "only_capable": ("", "", ""),
    "only_independent": ("", "", ""),
    "only_men": ("", "", ""),
    "only_playable": ("", "", ""),
    "only_rulers": ("", "", ""),
    "only_women": ("", "", ""),
    "opinion": ("Checks if the opinion is at least this value (Example opinion = { who = ROOT value = 25 } )", "character", "string"),
    "opinion_diff": ("", "", ""),
    "opinion_levy_raised_days": ("", "", ""),
    "overlord_of": ("", "", ""),
    "owns": ("", "", ""),
    "personality_traits": ("", "", ""),
    "piety": ("The amount of piety a character has.", "character", "int"),
    "plot_power": ("", "", ""),
    "port": ("", "", ""),
    "preparing_invasion": ("", "", ""),
    "prestige": ("The amount of prestige a character has.", "character", "int"),
    "prisoner": ("If No, can't be applied to imprisoned characters", "character", "bool"),
    "province": ("", "", ""),
    "province_capital": ("", "", ""),
    "province_id": ("", "", ""),
    "realm_diplomacy": ("", "", ""),
    "realm_intrigue": ("", "", ""),
    "realm_learning": ("", "", ""),
    "realm_martial": ("", "", ""),
    "realm_size": ("", "", ""),
    "realm_stewardship": ("", "", ""),
    "rebel": ("", "", ""),
    "relative_power": ("", "", ""),
    "relative_power_to_liege": ("", "", ""),
    "religion": ("", "", ""),
    "religion_authority": ("", "", ""),
    "religion_group": ("", "", ""),
    "reverse_has_opinion_modifier": ("", "", ""),
    "reverse_has_truce": ("", "", ""),
    "reverse_opinion": ("", "", ""),
    "revolt_risk": ("", "", ""),
    "rightful_religious_head": ("", "", ""),
    "ruled_years": ("", "", ""),
    "same_guardian": ("", "", ""),
    "same_liege": ("", "", ""),
    "same_realm": ("", "", ""),
    "same_religion": ("", "", ""),
    "scaled_wealth": ("", "", ""),
    "stewardship": ("A character's Stewardship stat.", "character", "int"),
    "temporary": ("", "", ""),
    "terrain": ("", "", ""),
    "their_opinion": ("", "", ""),
    "tier": ("", "", ""),
    "title": ("", "", ""),
    "total_claims": ("", "", ""),
    "trait": ("Checks if the character has this trait, example : ( trait = shy )", "character", "string"),
    "treasury": ("", "", ""),
    "using_cb": ("", "", ""),
    "vassal_of": ("", "", ""),
    "war": ("", "", ""),
    "war_score": ("", "", ""),
    "war_with": ("", "", ""),
    "was_conceived_a_bastard": ("", "", ""),
    "wealth": ("The minimum amount of gold this character should have", "character", "int"),
    "would_be_heir_under_law": ("", "", ""),
    "year": ("Returns the current year.", "", "int"),
}

had_flag_cond = ['had_character_flag', 'had_dynasty_flag',
                 'had_global_flag', 'had_province_flag']
had_flag_mask = """
def {}(flag, period):
    '''
        {} = value
        {}{}{}
    '''
    if '=' not in str(period):
        period = assign('days', period)
    flag = assign('flag', flag)
    return make_b('{}', flag + period)
"""
default_mask = """
def {}(value):
    '''
        {} = value
        {}{}{}
    '''
    return assign('{}', value)

"""
with open('cond_gen.py', 'w') as _fp:
    _fp.write('# -*- coding: utf-8 -*-\n')
    _fp.write('from base import assign,make_b\n')
    for acond in sorted(conditions.keys()):
        desc = conditions[acond][0]
        scope = conditions[acond][1]
        if scope:
            scope = 'from: ' + scope + '\n'
        typestr = conditions[acond][2]
        if typestr:
            typestr = 'type: ' + typestr + '\n'
        mask = default_mask
        if acond in had_flag_cond:
            mask = had_flag_mask
        _fp.write(mask.format(acond, acond, typestr, scope, desc, acond))

# commands are quite a bit more complicated to do.
# some are assigns and some are blocks...
# ergo, two different 'function' definitions.
BLOCK_CMD = {
    "activate_title": ("title", "status"),
    "add_character_modifier": ("name", "duration"),
    "add_province_modifier": ("name", "duration"),
    "build_holding": ("title", "type", 'holder'),
    "change_variable": ("which", "value"),
    "character_event": ("id", "days", 'tooltip'),
    "create_title": ('tier', "name", "holder"),
    "death": ("death_reason", "killer"),
    "gain_settlements_under_title": ("title", "enemy"),
    "letter_event": ("id", "days", 'tooltip'),
    "narrative_event": ("id", "days", 'tooltip'),
    "province_event": ("id", "days", 'tooltip'),
    # this can probably be days or months...
    "opinion": ("modifier", "who", 'years'),
    "religion_authority": ("modifier"),
    "remove_opinion ": ("who", "modifier"),
    "reverse_opinion": ("modifier", "who", 'years'),
    "reverse_remove_opinion ": ("modifier", "who"),
    "reverse_war": ("target", "casus_belli", 'thirdparty'),
    "set_opinion_levy_raised_days": ("who", "days"),
    "set_parent_religion": ("religion", "parent"),
    "set_variable": ("which", "value"),
    "spawn_fleet": ("", ""),
    "spawn_unit": ("", ""),
    "subjugate_or_take_under_title": ("", ""),
    "transfer_scaled_wealth": ("to", "value"),
    "vassalize_or_take_under_title": ("", ""),
    "change_variable": ("title", "enemy"),
    "vassalize_or_take_under_title_destroy_duchies": ("title", "enemy"),
}
commands = {
    "abandon_heresy": ("character", "", "abandon_heresy = yes"),
    "abdicate": ("character", "abdicate to current heir", "abdicate = yes"),
    "abdicate_to": ("", "", ""),
    "abdicate_to_most_liked_by": ("", "", ""),
    "activate_plot": ("", "", ""),
    "activate_title": ("any", "", "activate_title = { title = d_hashshashin status = no }"),
    "add_ambition": ("character", "", "add_ambition = obj_become_chancellor"),
    "add_betrothal": ("", "", ""),
    "add_building": ("", "", ""),
    "add_character_modifier": ("character", "", "add_character_modifier = { name = mod_bloodlust duration = 180 }"),
    "add_claim": ("title", "add a strong, non-inheritable claim to character", "county = { add_claim = ROOT }"),
    "add_consort": ("character", "", ""),
    "add_law": ("title", "", "random_demesne_title = { add_law = centralization_0 }"),
    "add_law_w_cooldown": ("", "", "any_demesne_title = { add_law_w_cooldown = investiture_law_0 }"),
    "add_lover": ("character", "", "add_lover = PREV"),
    "add_number_to_name": ("", "", ""),
    "add_objective": ("", "", ""),
    "add_piety_modifier": ("", "", ""),
    "add_pressed_claim": ("title", "add a strong, inheritable claim", "primary_title = { add_pressed_claim = ROOT }"),
    "add_prestige_modifier": ("", "", ""),
    "add_province_modifier": ("province", "", "add_province_modifier = { name = smugglers_ring duration = -1 }"),
    "add_spouse": ("character", "", "add_spouse = FROM"),
    "add_spouse_matrilineal": ("character", "", "add_spouse_matrilineal = FROM"),
    "add_trait": ("", "Adds a trait to the character, using an ID from the traits files", "add_trait = skilled_tactician"),
    "add_weak_claim": ("", "add a weak, non-inheritable claim", ""),
    "add_weak_pressed_claim": ("", "add a weak, inheritable claim", "add_weak_pressed_claim = FROM"),
    "approve_law": ("character, title", "", "primary_title = { approve_law = city_tax_0 }"),
    "back_plot": ("character", "", "ROOT = { back_plot = PREV }"),
    "banish": ("character", "banish character to random court", "FROM = { banish = yes }"),
    "banish_religion": ("character", "all characters of the targeted religion will be banished to random court", "banish_religion = jewish"),
    "become_heretic": ("character", "changes religion to random heresy of current religion", "become_heretic = yes"),
    "break_betrothal": ("", "", ""),
    "build_holding": ("province", "", "build_holding = { title = b_masyaf type = castle holder = ROOT }"),
    "cancel_ambition": ("character", "", "cancel_ambition = yes"),
    "cancel_job_action": ("character", "", "FROM = { cancel_job_action = action_inquisition }"),
    "cancel_objective": ("", "", ""),
    "cancel_plot": ("character", "", "cancel_plot = plot_gain_title"),
    "change_diplomacy": ("character", "", "change_diplomacy = 1"),
    "change_intrigue": ("character", "", "change_intrigue = 1"),
    "change_learning": ("character", "", "change_learning = 1"),
    "change_martial": ("character", "", "change_martial = 2"),
    "change_phase_to": ("", "", ""),
    "change_random_civ_tech": ("", "", ""),
    "change_random_eco_tech": ("", "", ""),
    "change_random_mil_tech": ("", "", ""),
    "change_stewardship": ("character", "", "change_stewardship = 1"),
    "change_variable": ("character", "", "change_variable = { which = \"bob_saget\" value = 1 }"),
    "check_actor_direct_vassals": ("", "", ""),
    "character_event": ("character", "", "character_event = { id = 66010 days = 17 tooltip = EVTTOOLTIP66010 }"),
    "clear_revolt": ("", "", "clear_revolt = yes"),
    "clear_wealth": ("character", "", "clear_wealth = yes"),
    "clr_character_flag": ("character", "", "clr_character_flag = flag_promised_marriage"),
    "clr_dynasty_flag": ("char'", "", "clr_dynasty_flag = strange_chest"),
    "clr_global_flag": ("any", "", "clr_global_flag = shepherds_crusade_active"),
    "clr_province_flag": ("province", "", "clr_province_flag = tournament_60_days_furusiyya"),
    "conquest_culture": ("province", "", "conquest_culture = PREVPREV"),
    "copy_title_history": ("title", "", "copy_title_history = k_asturias"),
    "copy_title_laws": ("title", "", "copy_title_laws = k_asturias"),
    "create_character": ("character, province", "creates a random character", "create_character = { ... }"),
    "create_random_diplomat": ("character, province", "creates a random character with diplomacy education", "create_random_diplomat = { ... }"),
    "create_random_intriguer": ("character, province", "creates a random character with intrigue education", "create_random_intriguer = { ... }"),
    "create_random_priest": ("character, province", "creates a random character with learning education", "create_random_priest = { ... }"),
    "create_random_soldier": ("character, province", "creates a random character with martial education", "create_random_soldier = { ... }"),
    "create_random_steward": ("character, province", "creates a random character with stewardship education", "create_random_steward = { ... }"),
    "create_title": ("character", "", "create_title = { tier = DUKE name = \"SHEPHERDS_CRUSADE\" holder = THIS }"),
    "culture_techpoints": ("character", "", "culture_techpoints = 50"),
    "cure_illness": ("character", "", "cure_illness = yes"),
    "de_jure_liege": ("title", "", "any_direct_de_jure_vassal_title = { de_jure_liege = e_roman_empire }"),
    "death": ("character", "", "death = { death_reason = death_execution killer = ROOT }"),
    "decadence": ("character", "", "decadence = -50"),
    "destroy_landed_title": ("title", "", "k_asturias = { destroy_landed_title = THIS }"),
    "destroy_random_building": ("province", "", "random_demesne_title = { destroy_random_building = yes }"),
    "destroy_tradepost": ("province", "", "destroy_tradepost = FROMFROM"),
    "disband_event_forces": ("character", "", "disband_event_forces = prepared_invasion"),
    "economy_techpoints": ("character", "", "economy_techpoints = -50"),
    "end_war": ("war", "", "end_war = invalid"),
    "excommunicate": ("character", "", "excommunicate = no"),
    "fertility": ("character", "", "fertility = 0.4"),
    "gain_all_occupied_titles": ("", "", ""),
    "gain_settlements_under_title": ("character", "", "gain_settlements_under_title = { title = PREV enemy = ROOT }"),
    "gain_title": ("title", "", "random_demesne_title = { gain_title = FROM }"),
    "gain_title_plus_barony_if_unlanded": ("", "", ""),
    "give_job_title": ("character", "", "give_job_title = job_chancellor"),
    "give_minor_title": ("character", "", "give_minor_title = title_chief_qadi"),
    "give_nickname": ("character", "gives the character a nickname", "give_nickname = nick_the_great"),
    "gold": ("", "", ""),
    "grant_kingdom_w_adjudication": ("title", "", "random_demesne_title = { grant_kingdom_w_adjudication = FROM }"),
    "grant_title": ("title", "", "random_claim = { grant_title = FROM }"),
    "grant_title_no_opinion": ("", "", ""),
    "health": ("character", "", "health = -1"),
    "impregnate": ("character", "", "impregnate = ROOT"),
    "impregnate_cuckoo": ("character", "", "impregnate_cuckoo = ROOT"),
    "imprison": ("character", "scoped character will be imprisoned by target", "imprison = ROOT"),
    "inherit": ("character", "scoped character will inherit targets titles", "random_courtier = { inherit = ROOT }"),
    "join_attacker_wars": ("character", "", "ROOT = { join_attacker_wars = PREV }"),
    "join_defender_wars": ("character", "", "FROM = { join_defender_wars = ROOT }"),
    "leave_plot": ("character", "", "leave_plot = FROM"),
    "letter_event": ("character", "", "letter_event = { id = 88752 days = 4 tooltip = \"EVTTOOLTIP88751\" }"),
    "make_primary_spouse": ("character", "scoped character will become primary spouse", "FROM = { make_primary_spouse = yes }"),
    "make_primary_title": ("title", "", "k_leon = { make_primary_title = yes }"),
    "military_techpoints": ("character", "", "military_techpoints = -50"),
    "move_character": ("character", "scoped character will be moved to targeted characters court", "FROM = { move_character = ROOT }"),
    "narrative_event": ("character", "", "narrative_event = { id = 88007 days = 2 }"),
    "occupy_minors_of_occupied_settlements": ("character", "", "occupy_minors_of_occupied_settlements = FROM"),
    "opinion": ("character", "", "opinion = { modifier = dynastic_refused_claim who = ROOT years = 5 }"),
    "piety": ("character", "", "piety = 10"),
    "prestige": ("character", "", "prestige = -20"),
    "province_event": ("province", "", "province_event = { id = 8512 days = 1 }"),
    "random": ("any", "", "random = { chance = 5 add_trait = wounded }"),
    "random_list": ("any", "", "random_list = { 50 = { ... } 50 = { ... } }"),
    "rebel_defection": ("title", "", "rebel_defection = yes"),
    "recalc_succession": ("any", "", "recalc_succession = yes"),
    "reduce_disease": ("province", "", "random_demesne_province = { reduce_disease = 0.33 }"),
    "religion_authority": ("any", "", "religion_authority = { modifier = ruler_converted_from }"),
    "remove_building": ("", "", ""),
    "remove_character_modifier": ("character", "", "remove_character_modifier = promised_a_title"),
    "remove_claim": ("character", "", "remove_claim = k_papal_state ; any_claim = { remove_claim = PREV }"),
    "remove_friend": ("character", "", "remove_friend = FROM"),
    "remove_holding_modifier": ("title", "", "remove_holding_modifier = recently_conquered"),
    "remove_lover": ("character", "remove scoped character's lover", "remove_lover = yes"),
    "remove_opinion": ("character", "", "remove_opinion = { who = FROM modifier = opinion_friend }"),
    "remove_province_modifier": ("province", "", "remove_province_modifier = thieves_guild"),
    "remove_settlement": ("", "", ""),
    "remove_spouse": ("character", "remove scoped character's spouse", "remove_spouse = spouse"),
    "remove_title": ("character", "", "remove_title = job_chancellor"),
    "remove_trait": ("character", "", "remove_trait = charitable"),
    "reveal_plot": ("character", "reveal scoped characters plot", "reveal_plot = yes"),
    "reveal_plot_w_message": ("character", "reveal scoped characters plot", "reveal_plot_w_message = yes"),
    "reverse_banish": ("character", "", "random_realm_lord = { reverse_banish = FROM }"),
    "reverse_culture": ("character, province", "change the target's culture to the one of current scope", "reverse_culture = PREV"),
    "reverse_imprison": ("character", "", "FROM = { reverse_imprison = ROOT }"),
    "reverse_opinion": ("character", "", "reverse_opinion = { modifier = opinion_dislike who = FROM years = 5 }"),
    "reverse_religion": ("character", "", "reverse_religion = PREV"),
    "reverse_remove_opinion": ("character", "", "reverse_remove_opinion = { who = ROOT modifier = opinion_friend }"),
    "reverse_war": ("title", "", "random_claim = { reverse_war = { target = from casus_belli = other_claim thirdparty = root } }"),
    "revoke_law": ("title", "", "revoke_law = investiture_law_1"),
    "scaled_wealth": ("character", "", "scaled_wealth = -0.15"),
    "seize_trade_post": ("province", "", "any_neighbor_province = { seize_trade_post = ROOT }"),
    "send_assassin": ("character", "", "send_assassin = FROMFROM"),
    "set_allow_free_infidel_revokation": ("", "", ""),
    "set_allow_free_revokation": ("", "", ""),
    "set_allow_title_revokation": ("", "", ""),
    "set_appoint_generals": ("", "", ""),
    "set_appoint_regents": ("", "", ""),
    "set_character_flag": ("character", "", "set_character_flag = decadence_drunkard"),
    "set_defacto_liege": ("character", "", "set_defacto_liege = FROM"),
    "set_defacto_vassal": ("character", "", "holder_scope = { set_defacto_vassal = PREVPREV }"),
    "set_dynasty_flag": ("character", "", "set_dynasty_flag = the_victims"),
    "set_father": ("character", "", "set_father = PREV"),
    "set_global_flag": ("any", "", "set_global_flag = west_francia_renamed"),
    "set_guardian": ("character", "", "set_guardian = ROOT"),
    "set_investiture": ("", "", ""),
    "set_mother": ("character", "", "set_mother = PREV"),
    "set_name": ("character, title", "", "b_kolbatz = { set_name = Jomsborg }"),
    "set_opinion_levy_raised_days": ("character", "", "set_opinion_levy_raised_days = { who = ROOT days = 0 }"),
    "set_parent_religion": ("any", "", "set_parent_religion = { religion = catholic parent = orthodox }"),
    "set_protected_inheritance": ("", "", ""),
    "set_province_flag": ("province", "", "set_province_flag = home_of_jeanne_darc"),
    "set_the_kings_full_peace": ("", "allow/disallow vassals to wage war", "set_the_kings_full_peace = yes"),
    "set_the_kings_peace": ("", "allow/disallow vassals to wage war between them", "set_the_kings_peace = no"),
    "set_variable": ("character", "", "change_variable = { which = \"bob_saget\" value = 1 } NOTE: Does Throw errors everytime it is called but seems to work nontheless"),
    "spawn_fleet": ("character", "", "spawn_fleet = { province = PREV owner = ROOT troops = { ... } }"),
    "spawn_unit": ("character", "", "spawn_unit = { province = PREV owner = ROOT troops = { ... } }"),
    "steal_random_tech": ("", "", ""),
    "subjugate_or_take_under_title": ("character", "", "subjugate_or_take_under_title = { title = PREV enemy = FROM }"),
    "succession": ("title", "", "succession = primogeniture"),
    "succession_w_cooldown": ("title", "", "succession_w_cooldown = primogeniture"),
    "transfer_scaled_wealth": ("character", "", "transfer_scaled_wealth = { to = FROM value = 0.25 }"),
    "treasury": ("character", "", "treasury = -20"),
    "usurp_title": ("title", "", "c_pest = { usurp_title = ROOT }"),
    "usurp_title_only": ("title", "", "usurp_title_only = ROOT"),
    "usurp_title_plus_barony_if_unlanded": ("title", "", "plot_target_title = { usurp_title_plus_barony_if_unlanded = PREV }"),
    "usurp_title_plus_barony_if_unlanded_and_vassals": ("title", "targeted character will usurp scoped title", "c_byzantion = { usurp_title_plus_barony_if_unlanded_and_vassals = PREV }"),
    "vassalize_or_take_under_title": ("character", "", "vassalize_or_take_under_title = { title = PREV enemy = FROM }"),
    "vassalize_or_take_under_title_destroy_duchies": ("character", "", "vassalize_or_take_under_title_destroy_duchies = { title = PREV enemy = FROM }"),
    "wealth": ("character", "", "wealth = -50"),
}


line = """
def {}(value):
    '''
        {} = value
        {}{}{}
    '''
    return assign('{}', value)

"""
with open('cmd_gen.py', 'w') as _fp:
    _fp.write('# -*- coding: utf-8 -*-\n')
    _fp.write('from base import assign\n')
    for cmd in sorted(commands.keys()):
        if cmd not in BLOCK_CMD:
            scope = commands[cmd][0]
            desc = commands[cmd][1]
            example = commands[cmd][2]
            if scope:
                scope = 'from: ' + scope + '\n'
            if desc:
                desc += '\n'
            if example:
                example += '\n'
            _fp.write(line.format(cmd, cmd, scope, desc, example, cmd))
