# this file holds defines common to CK2 that don't
#   change very often.


import re
import ctypes.wintypes


def find_current_user_docs_dir():
    csidl_personal = 5  # My Documents
    shgfp_type_current = 0  # Want current, not default value
    buf = ctypes.create_unicode_buffer(ctypes.wintypes.MAX_PATH)
    ctypes.windll.shell32.SHGetFolderPathW(
        0, csidl_personal, 0, shgfp_type_current, buf)
    my_docs_base = buf.value
    return my_docs_base

EXTRA_HOLDING_TYPES = ['fort', 'trade_post', 'hospital']

BLOCK_GENERATES_EMPTY_ITEMS = True
PRETTIFY_WITH_SPACES = False
PRETTY_SPACES_TO_USE = 4
# move this to Config File
CK2DIR = r"D:\Games\steam\steamapps\common\Crusader Kings II"
try:
    MODSFOLDER = find_current_user_docs_dir(
    ) + "\\Paradox Interactive\\Crusader Kings II\\mod\\"
except:
    print "Locating mods folder failed, please set MODSFOLDER manually."
    MODSFOLDER = "..\\"
    raise
VERBOSE_SIMPLIFY = True
NOTIFY_MISSING_DIRECTORIES = False
# GENERATE_EMPTY_ITEMS if true, generates code for empty things
# PRETTIFY_WITH_SPACES if fales uses PRETTY_SPACES_TO_USE spaces instead of tab.
# PRETTY_SPACES_TO_USE controls how many spaces for each 'tab' if
# PRETTIFY_WITH_SPACES is enabled.

# global vars
LINES_PARSED = 0

# import __cfunc__

MINOR_TITLE_NUMBERS=[
    'dignity',
    'grant_limit',
    'opinion_effect',    
    'monthly_salary',
    'monthly_prestige',
]
MINOR_TITLE_STRINGS = [
    'dignity',
    'is_high_prio',
    'show_as_title',
    'realm_in_name',
    'is_voter',
    'attribute',
    'is_unique',
    'message',
    'patrician_heir'
]
MINOR_TITLE_BLOCKS = [
    'allowed_to_hold',
    'allowed_to_grant',
    'gain_effect',
    'revoke_trigger',
    'lose_effect',
    'retire_effect',
]